import { EventEmitter2, EventEmitterModule } from '@nestjs/event-emitter';
import { Test, TestingModule } from '@nestjs/testing';
import { PrismaService } from '@modules/user/infrastructure/prisma.service';
import { UserRepository } from '@modules/user/infrastructure/user.repository';
import { UserMapper } from '@modules/user/user.mapper';

const mockMessagePublisher = {
  publish: jest.fn().mockImplementation(),
};

describe('User repository', () => {
  let prismaService: PrismaService;
  let userMapper: UserMapper;
  let eventEmitter: EventEmitter2;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      imports: [EventEmitterModule.forRoot()],
      providers: [PrismaService, UserMapper],
    }).compile();

    prismaService = module.get<PrismaService>(PrismaService);
    userMapper = module.get<UserMapper>(UserMapper);
    eventEmitter = module.get<EventEmitter2>(EventEmitter2);
  });
  it('should be defined', () => {
    expect(
      new UserRepository(
        prismaService,
        userMapper,
        eventEmitter,
        mockMessagePublisher,
      ),
    ).toBeDefined();
  });
});
